/*******************************************************************************
*  FSLP.c | XChXCb`@\tZT(FSLP)̃eXg                    *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2013-01-09  ޒH[(ނ)  Create                            *
*  1.10    2015-10-26  ޒH[(ނ)  MPLAB XEXC8 V1.32pɏ      *
* ============================================================================ *
*  PIC 16F1827                                                                 *
*  MPLAB X(v2.15)                                                              *
*  MPLAB(R) XC8 C Compiler Version 1.32                                        *
*******************************************************************************/
#include <xc.h>
#include <stdlib.h>
#include "skUARTlib.h"
#include "skMonitorUART.h"

#define _XTAL_FREQ 8000000    // delaypɕKv(NbN8MHzw)
#define SL_PIN  RA2           // FSLP̒[qP(SL)ƐڑĂPICsw肷
#define D1_PIN  RA3           // FSLP̒[qQ(D1)ƐڑĂPICsw肷
#define D2_PIN  RA4           // FSLP̒[qR(D2)ƐڑĂPICsw肷
#define RO_PIN  RA1           // R(4.7K)ڑĂPICsw肷


// RtBM[VP̐ݒ
#pragma config FOSC = INTOSC    // ۯgp(INTOSC)
#pragma config WDTE = OFF       // ޯϰ(OFF)
#pragma config PWRTE = ON       // dON64ms۸тJn(ON)
#pragma config MCLRE = OFF      // OؾĐM͎gp޼ٓ(RA5)݂Ƃ(OFF)
#pragma config CP = OFF         // ۸ذی삵Ȃ(OFF)
#pragma config CPD = OFF        // ްذی삵Ȃ(OFF)
#pragma config BOREN = ON       // dd~펞Ď@\ON(ON)
#pragma config CLKOUTEN = OFF   // CLKOUT݂RA6݂Ŏgp(OFF)
#pragma config IESO = OFF       // OEۯ̐ؑւł̋N͂Ȃ(OFF)
#pragma config FCMEN = OFF      // OۯĎȂ(FCMEN_OFF)

// RtBM[VQ̐ݒ
#pragma config WRT = OFF        // Flashذی삵Ȃ(OFF)
#pragma config PLLEN = OFF      // NbN32MHzł͓삳Ȃ(OFF)
#pragma config STVREN = ON      // X^bNI[ot[A_[t[烊Zbg(ON)
#pragma config BORV = HI        // dd~펞Ďd(2.5V)ݒ(HI)
#pragma config LVP = OFF        // dvO~O@\gpȂ(OFF)

/*******************************************************************************
*  AiOl̕ϊƓǍݏ                                                *
*******************************************************************************/
unsigned int adconv()
{
     unsigned int temp;

     GO_nDONE = 1 ;	      // AiOlǎJnw
     while(GO_nDONE) ;        // ǎ芮܂ő҂
     temp = ADRESH ;
     temp = ( temp << 8 ) | ADRESL ;

     return temp ;
}
/*******************************************************************************
* FSLP_Reset()                                                                 *
*  ZT[̓dׂ鏈                                                *
*******************************************************************************/
void FSLP_Reset()
{
     // fW^h^nɐݒ肷
     ANSA1 = 0 ; // RO
     ANSA2 = 0 ; // SL
     ANSA3 = 0 ; // D1
     ANSA4 = 0 ; // D2
     // fW^o͂ɐݒ肷
     TRISA1 = 0 ; // RO
     TRISA2 = 0 ; // SL
     TRISA3 = 0 ; // D1
     TRISA4 = 0 ; // D2
     // FSLP̊esLOWɐݒ肷(SڑsGNDɗƂēdׂ𓦂)
     RO_PIN = 0 ;
     SL_PIN = 0 ;
     D1_PIN = 0 ;
     D2_PIN = 0 ;
}
/*******************************************************************************
* ans = FSLP_ReadPosition()                                                    *
*  ꏊ̈ʒuǂݎ鏈                                              *
*  ans FʒuɉlԂ܂                                        *
*******************************************************************************/
int FSLP_ReadPosition()
{
     int ans , i ;

     // dׂ
     FSLP_Reset() ; 
     // dZbg
     D1_PIN = 1 ;             // D1[qHIGH
     D2_PIN = 0 ;             // D2[qLOW
     RO_PIN = 0 ;             // RO[qLOW
     // SL[qAiOɐݒ肷
     ANSA2  = 1 ;
     TRISA2 = 1 ;
     ADCON1 = 0b10010000 ;    // ǎl͉E񂹁AA/DϊNbNFOSC/8AVDDt@XƂ
     ADCON0 = 0b00001001 ;    // AiOϊݒ(AN2Ǎ)
     __delay_us(5) ;          // 
     // RO[q͂ɂ
     RO_PIN = 0 ;
     ANSA1  = 0 ;
     TRISA1 = 1 ;
     __delay_us(5) ;          // 
     // SL[qAiOl(ʒu)ǂݍ
     ans = 0 ;
     for(i=0;i<15;i++) {
          ans = ans + adconv() ;
     }
     ans = ans / 15 ;
     ADON = 0 ;               // AiO~

     return(ans) ;
}
/*******************************************************************************
* ans = FSLP_ReadPressure()                                                    *
*  ꏊ̉͂킢()ǂݎ鏈                                *
*  ans F͂ɉlԂ܂                                        *
*******************************************************************************/
int FSLP_ReadPressure()
{
     int ans ;
     int v1 , v2 ;

     // dׂ
     FSLP_Reset() ; 
     // dZbg
     D1_PIN = 1 ;             // D1[qHIGH
     // SL[qAiO͂ɂ
     ANSA2  = 1 ;
     TRISA2 = 1 ;
     // D2[qAiO͂ɂ
     ANSA4  = 1 ;
     TRISA4 = 1 ;
     RO_PIN = 0 ;             // RO[qLOW
     // AiO̐ݒƓǂݍ
     ADCON1 = 0b10010000 ;    // ǎl͉E񂹁AA/DϊNbNFOSC/8AVDDt@XƂ
     ADCON0 = 0b00001001 ;    // AiOϊݒ(AN2Ǎ)
     __delay_us(5) ;          // 
     v2 = adconv() ;
     ADCON0 = 0b00010001 ;    // AiOϊݒ(AN4Ǎ)
     __delay_us(5) ;          // 
     v1 = adconv() ;
     ans = (64 * v2) / (v1-v2) ;
     ADON = 0 ;               // AiO~

     return(ans) ;
}
/*******************************************************************************
*  C̏                                                                *
*******************************************************************************/
void main()
{
     int  ans ;
     char dt[8] ;

     OSCCON = 0b01110010 ;    // NbN͂WlgƂ
     ANSELA = 0b00000000 ;    // AN0-AN4͎gpȂSăfW^I/OƂ
     ANSELB = 0b00000000 ;    // AN5-AN11͎gpȂSăfW^I/OƂ
     TRISA  = 0b00000000 ;    // RAs͑Sďo͂ɊĂ(RA5͓͐p)
     TRISB  = 0b00000010 ;    // RB1(RX)̂ݓ́Ãs(RB)͏o͂ɊĂ
     PORTA  = 0b00000000 ;    // RAo̓s̏(SLOWɂ)
     PORTB  = 0b00000000 ;    // RBo̓s̏(SLOWɂ)

     InitUART(7,8,51) ;       // RX=7 TX=8 9600bps USART

     while(1) {
          ans = FSLP_ReadPressure() ;
          MonitorPuts("PRES=") ;        // ꏊ̉͂ǂݎ
          itoa(dt,ans,10) ;             // l𕶎ɕϊ
          MonitorPuts(dt) ;
          ans = FSLP_ReadPosition() ;   // ꏊ̈ʒuǂݎ
          MonitorPuts("  POSI=") ;
          itoa(dt,ans,10) ;             // l𕶎ɕϊ
          MonitorPuts(dt) ;
          MonitorPuts("\r\n") ;
          // 500msɌJԂ
          __delay_ms(500) ;
     }

}