/*******************************************************************************
*  skUARTlib - tr`qs֐Cu                                        *
*          ̃CuUSART(VAʐM)sׂ̊֐Wł             *
*                                                                              *
*    InterUART      - tr`qs֘Å荞ݏ                             *
*    InitUART       - tr`qsʐM̏s                         *
*    UART_Send      - Ɏw肵̃f[^𑗐M鏈                 *
*    UART_Write     - ɂPoCg̃f[^𑗐M鏈                     *
*    UART_Available - Mf[^̌Ԃ                           *
*    UART_Read      - Mf[^PoCgǂݍޏ                     *
*    UART_Flush     - Mobt@NA鏈                             *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2013-01-20  ޒH[(ނ)  Create                            *
*  1.10    2013-02-18  ޒH[(ނ)  UART_Flush֐̒ǉ              *
*  2.00    2015-05-25  ޒH[(ނ)  16F1825/1829 18F2xK22 Ή        *
* ============================================================================ *
*  PIC 12F1822 16F1705 16F182x 16F1938/19xx 18F2xK22 1814K50 18F8722           *
*  MPLAB IDE(V8.84)                                                            *
*  MPLAB(R) XC8 C Compiler Version 1.00                                        *
*******************************************************************************/
#include <xc.h>
#include "skUARTlib.h"


char UART_Buffer[UART_BUFFER_SIZE] ;    // Mf[^i[obt@
int  UART_Buffer_inptr ;                // Mobt@̓ǂݍ݃|C^[
int  UART_Buffer_outptr ;               // Mobt@̏݃|C^[


/*******************************************************************************
*  InterUART( void )                                                           *
*    tr`qs֘Å荞ݏ                                              *
*     ̊֐͎Msꍇ̓CvO̊݊֐ŕKĂт܂     *
*******************************************************************************/
void InterUART( void )
{
     int  x ;
     char dt ;

     if (RC0IF == 1) {        // ݂͂tr`qsʐM̎MH
          // WX^f[^M
          dt = RCREG0 ;
          x = (UART_Buffer_outptr + 1) % UART_BUFFER_SIZE ;
          if (x != UART_Buffer_inptr) {
               // obt@tłȂȂf[^ۑ
               UART_Buffer[UART_Buffer_outptr] = dt ;
               // obt@݃|C^[ɐi߂
               UART_Buffer_outptr = x ;
          }

          // I[oG[(RCREGobt@Rڂ̃f[^MI[ot[)
          if (RCSTA_OERR == 1) {
               RCSTA_CREN = 0 ;
               while( RCSTA_OERR ) ;
               RCSTA_CREN = 1 ;
          }

          // ݎMtOZbg
          RC0IF = 0 ;
     }
}
/*******************************************************************************
*  InitUART(rx,tx,brg)                                                         *
*    tr`qsʐM̏s                                          *
*    rx  : M(RX)s̔ԍw肷                                    *
*    tx  : M(TX)s̔ԍw肷                                    *
*    brg : {[[gWFl[^̒lw肵܂(ʐMxɂȂ܂)          *
*          (SYNC=0 BRGH=1 BRG16=0)                                             *
*                    4MHz  8MHz 16MHz 32MHz 40MHz 48MHz 64MHz                  *
*           9600bps   25    51   103   207    x     x     x                    *
*          19200bps   12    25    51   103   129   155   207                   *
*******************************************************************************/
void InitUART(int rx, int tx, char brg)
{
#if defined(_12F1822)
     RXDTSEL = 0 ;                 // 6ԃs(RA1)RXMsƂ
     TXCKSEL = 0 ;                 // 7ԃs(RA0)TXMsƂ
     if (rx == 2) RXDTSEL = 1 ;    // 2ԃs(RA5)RXMsƂ
     if (tx == 3) TXCKSEL = 1 ;    // 3ԃs(RA4)TXMsƂ
#endif

#if defined(_16F1823) || defined(_16F1825)
     RXDTSEL = 0 ;                 //  5ԃs(RC5)RXMsƂ
     TXCKSEL = 0 ;                 //  6ԃs(RC4)TXMsƂ
     if (rx == 12) RXDTSEL = 1 ;   // 12ԃs(RA1)RXMsƂ
     if (tx == 13) TXCKSEL = 1 ;   // 13ԃs(RA0)TXMsƂ
#endif

#if defined(_16F1826) || defined(_16F1827)
     RXDTSEL = 0 ;                 //  7ԃs(RB1)RXMsƂ
     TXCKSEL = 0 ;                 //  8ԃs(RB2)TXMsƂ
     if (rx == 8)  RXDTSEL = 1 ;   //  8ԃs(RB2)RXMsƂ
     if (tx == 11) TXCKSEL = 1 ;   // 11ԃs(RB5)TXMsƂ
#endif

#if defined(_16F1829)
     RXDTSEL = 0 ;                 // 12ԃs(RB5)RXMsƂ
     TXCKSEL = 0 ;                 // 10ԃs(RB7)TXMsƂ
     if (rx == 5) RXDTSEL = 1 ;    //  5ԃs(RC5)RXMsƂ
     if (tx == 6) TXCKSEL = 1 ;    //  6ԃs(RC4)TXMsƂ
#endif

     TXSTA0 = 0b00100100 ;         // MݒF񓯊[h@WrbgEmpeB
     RXSTA0 = 0b10010000 ;         // Mݒ
     SPBRG0 = brg ;                // {[[g̐ݒ
     RC0IF  = 0 ;                  // USARTݎMtȌ
     RC0IE  = 1 ;                  // USARTݎMLɂ
     PEIE   = 1 ;                  // ӑu݂Lɂ
     GIE    = 1 ;                  // Sݏ
     UART_Buffer_inptr  = 0 ;      // Mobt@̓ǂݍ݃|C^[̏
     UART_Buffer_outptr = 0 ;      // Mobt@̏݃|C^[̏
}
/*******************************************************************************
*  UART_Send(dt,num)                                                           *
*    Ɏw肵̃f[^𑗐M鏈                                  *
*                                                                              *
*    dt  : Mf[^i[zw肵܂B                          *
*    num : Mf[^̌w肵܂B                                  *
*******************************************************************************/
void UART_Send(const char *dt,int num)
{
     int i ;

     // w肵JԂ
     for (i=0 ; i<num ; i++) {
          while(TX0IF==0) ;   // M\ɂȂ܂ő҂
          TXREG0 = *dt++ ;    // M
     }
}
/*******************************************************************************
*  UART_Write(dt)                                                              *
*    ɂPoCg̃f[^𑗐M鏈                                      *
*                                                                              *
*    dt  : Mf[^w肵܂B                                        *
*******************************************************************************/
void UART_Write(char dt)
{
     while(TX0IF==0) ;        // M\ɂȂ܂ő҂
     TXREG0 = dt ;            // M
}
/*******************************************************************************
*  ans = UART_Available()                                                      *
*    Mf[^̌Ԃ                                            *
*                                                                              *
*    ans : Mf[^̌Ԃ܂B                                    *
*******************************************************************************/
int UART_Available()
{
     return (UART_Buffer_outptr + UART_BUFFER_SIZE - UART_Buffer_inptr) % UART_BUFFER_SIZE ;
}
/*******************************************************************************
*  ans = UART_Read()                                                           *
*    Mf[^PoCgǂݍޏ                                      *
*                                                                              *
*    ans : Mf[^Ԃ܂  0xffffԂMf[^͋łB      *
*******************************************************************************/
unsigned int UART_Read()
{
     unsigned int  ans ;

     // obt@͋ł
     if (UART_Buffer_inptr == UART_Buffer_outptr) return 0xffff ;
     // obt@ǂݏo
     ans = UART_Buffer[UART_Buffer_inptr] ;
     // obt@ǂݍ݃|C^[ɐi߂
     UART_Buffer_inptr = (UART_Buffer_inptr + 1) % UART_BUFFER_SIZE ;

     return ans ;
}
/*******************************************************************************
*  UART_Flush()                                                                *
*    Mobt@NA鏈                                              *
*******************************************************************************/
void UART_Flush()
{
     UART_Buffer_inptr  = 0 ;      // Mobt@̓ǂݍ݃|C^[̏
     UART_Buffer_outptr = 0 ;      // Mobt@̏݃|C^[̏
}
